package ecs

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DeleteLaunchTemplate invokes the ecs.DeleteLaunchTemplate API synchronously
// api document: https://help.aliyun.com/api/ecs/deletelaunchtemplate.html
func (client *Client) DeleteLaunchTemplate(request *DeleteLaunchTemplateRequest) (response *DeleteLaunchTemplateResponse, err error) {
	response = CreateDeleteLaunchTemplateResponse()
	err = client.DoAction(request, response)
	return
}

// DeleteLaunchTemplateWithChan invokes the ecs.DeleteLaunchTemplate API asynchronously
// api document: https://help.aliyun.com/api/ecs/deletelaunchtemplate.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DeleteLaunchTemplateWithChan(request *DeleteLaunchTemplateRequest) (<-chan *DeleteLaunchTemplateResponse, <-chan error) {
	responseChan := make(chan *DeleteLaunchTemplateResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DeleteLaunchTemplate(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DeleteLaunchTemplateWithCallback invokes the ecs.DeleteLaunchTemplate API asynchronously
// api document: https://help.aliyun.com/api/ecs/deletelaunchtemplate.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DeleteLaunchTemplateWithCallback(request *DeleteLaunchTemplateRequest, callback func(response *DeleteLaunchTemplateResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DeleteLaunchTemplateResponse
		var err error
		defer close(result)
		response, err = client.DeleteLaunchTemplate(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DeleteLaunchTemplateRequest is the request struct for api DeleteLaunchTemplate
type DeleteLaunchTemplateRequest struct {
	*requests.RpcRequest
	LaunchTemplateName   string           `position:"Query" name:"LaunchTemplateName"`
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	LaunchTemplateId     string           `position:"Query" name:"LaunchTemplateId"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
}

// DeleteLaunchTemplateResponse is the response struct for api DeleteLaunchTemplate
type DeleteLaunchTemplateResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateDeleteLaunchTemplateRequest creates a request to invoke DeleteLaunchTemplate API
func CreateDeleteLaunchTemplateRequest() (request *DeleteLaunchTemplateRequest) {
	request = &DeleteLaunchTemplateRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Ecs", "2014-05-26", "DeleteLaunchTemplate", "ecs", "openAPI")
	return
}

// CreateDeleteLaunchTemplateResponse creates a response to parse from DeleteLaunchTemplate response
func CreateDeleteLaunchTemplateResponse() (response *DeleteLaunchTemplateResponse) {
	response = &DeleteLaunchTemplateResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
