// Code generated by protoc-gen-go. DO NOT EDIT.
// source: yandex/cloud/iam/v1/awscompatibility/access_key.proto

package awscompatibility

import (
	fmt "fmt"
	proto "github.com/golang/protobuf/proto"
	timestamp "github.com/golang/protobuf/ptypes/timestamp"
	math "math"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

// An access key.
// For more information, see [AWS-compatible access keys](/docs/iam/concepts/authorization/access-key).
type AccessKey struct {
	// ID of the AccessKey resource.
	// It is used to manage secret credentials: an access key ID and a secret access key.
	Id string `protobuf:"bytes,1,opt,name=id,proto3" json:"id,omitempty"`
	// ID of the service account that the access key belongs to.
	ServiceAccountId string `protobuf:"bytes,2,opt,name=service_account_id,json=serviceAccountId,proto3" json:"service_account_id,omitempty"`
	// Creation timestamp.
	CreatedAt *timestamp.Timestamp `protobuf:"bytes,3,opt,name=created_at,json=createdAt,proto3" json:"created_at,omitempty"`
	// Description of the access key. 0-256 characters long.
	Description string `protobuf:"bytes,4,opt,name=description,proto3" json:"description,omitempty"`
	// ID of the access key.
	// The key is AWS compatible.
	KeyId                string   `protobuf:"bytes,5,opt,name=key_id,json=keyId,proto3" json:"key_id,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *AccessKey) Reset()         { *m = AccessKey{} }
func (m *AccessKey) String() string { return proto.CompactTextString(m) }
func (*AccessKey) ProtoMessage()    {}
func (*AccessKey) Descriptor() ([]byte, []int) {
	return fileDescriptor_0a09bbde32ee7837, []int{0}
}

func (m *AccessKey) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_AccessKey.Unmarshal(m, b)
}
func (m *AccessKey) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_AccessKey.Marshal(b, m, deterministic)
}
func (m *AccessKey) XXX_Merge(src proto.Message) {
	xxx_messageInfo_AccessKey.Merge(m, src)
}
func (m *AccessKey) XXX_Size() int {
	return xxx_messageInfo_AccessKey.Size(m)
}
func (m *AccessKey) XXX_DiscardUnknown() {
	xxx_messageInfo_AccessKey.DiscardUnknown(m)
}

var xxx_messageInfo_AccessKey proto.InternalMessageInfo

func (m *AccessKey) GetId() string {
	if m != nil {
		return m.Id
	}
	return ""
}

func (m *AccessKey) GetServiceAccountId() string {
	if m != nil {
		return m.ServiceAccountId
	}
	return ""
}

func (m *AccessKey) GetCreatedAt() *timestamp.Timestamp {
	if m != nil {
		return m.CreatedAt
	}
	return nil
}

func (m *AccessKey) GetDescription() string {
	if m != nil {
		return m.Description
	}
	return ""
}

func (m *AccessKey) GetKeyId() string {
	if m != nil {
		return m.KeyId
	}
	return ""
}

func init() {
	proto.RegisterType((*AccessKey)(nil), "yandex.cloud.iam.v1.awscompatibility.AccessKey")
}

func init() {
	proto.RegisterFile("yandex/cloud/iam/v1/awscompatibility/access_key.proto", fileDescriptor_0a09bbde32ee7837)
}

var fileDescriptor_0a09bbde32ee7837 = []byte{
	// 285 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x8c, 0x90, 0x41, 0x4b, 0xfb, 0x30,
	0x18, 0xc6, 0xe9, 0xfe, 0xff, 0x0d, 0x96, 0x81, 0x48, 0x40, 0x28, 0xbb, 0x58, 0xc4, 0xc3, 0x0e,
	0x2e, 0x61, 0x8a, 0x07, 0xf1, 0x54, 0x6f, 0xc3, 0xdb, 0xf0, 0xa2, 0x1e, 0x4a, 0x9a, 0xbc, 0xd6,
	0x97, 0x36, 0x4d, 0x69, 0xd2, 0x6a, 0x3e, 0x9c, 0xdf, 0x4d, 0x4c, 0x36, 0x90, 0x9d, 0xbc, 0xbe,
	0xcf, 0xfb, 0x7b, 0x9e, 0x87, 0x87, 0xdc, 0x7a, 0xd1, 0x2a, 0xf8, 0xe4, 0xb2, 0x31, 0x83, 0xe2,
	0x28, 0x34, 0x1f, 0x37, 0x5c, 0x7c, 0x58, 0x69, 0x74, 0x27, 0x1c, 0x96, 0xd8, 0xa0, 0xf3, 0x5c,
	0x48, 0x09, 0xd6, 0x16, 0x35, 0x78, 0xd6, 0xf5, 0xc6, 0x19, 0x7a, 0x19, 0x31, 0x16, 0x30, 0x86,
	0x42, 0xb3, 0x71, 0xc3, 0x8e, 0xb1, 0xe5, 0x79, 0x65, 0x4c, 0xd5, 0x00, 0x0f, 0x4c, 0x39, 0xbc,
	0x71, 0x87, 0x1a, 0xac, 0x13, 0xba, 0x8b, 0x36, 0x17, 0x5f, 0x09, 0x99, 0xe7, 0xc1, 0xfb, 0x11,
	0x3c, 0x3d, 0x21, 0x13, 0x54, 0x69, 0x92, 0x25, 0xab, 0xf9, 0x6e, 0x82, 0x8a, 0x5e, 0x11, 0x6a,
	0xa1, 0x1f, 0x51, 0x42, 0x21, 0xa4, 0x34, 0x43, 0xeb, 0x0a, 0x54, 0xe9, 0x24, 0xe8, 0xa7, 0x7b,
	0x25, 0x8f, 0xc2, 0x56, 0xd1, 0x3b, 0x42, 0x64, 0x0f, 0xc2, 0x81, 0x2a, 0x84, 0x4b, 0xff, 0x65,
	0xc9, 0x6a, 0x71, 0xbd, 0x64, 0xb1, 0x01, 0x3b, 0x34, 0x60, 0x4f, 0x87, 0x06, 0xbb, 0xf9, 0xfe,
	0x3b, 0x77, 0x34, 0x23, 0x0b, 0x05, 0x56, 0xf6, 0xd8, 0x39, 0x34, 0x6d, 0xfa, 0x3f, 0x24, 0xfc,
	0x3e, 0xd1, 0x33, 0x32, 0xab, 0xc1, 0xff, 0xc4, 0x4f, 0x83, 0x38, 0xad, 0xc1, 0x6f, 0xd5, 0xc3,
	0xeb, 0xcb, 0x73, 0x85, 0xee, 0x7d, 0x28, 0x99, 0x34, 0x9a, 0xc7, 0x4d, 0xd6, 0x71, 0xca, 0xca,
	0xac, 0x2b, 0x68, 0x43, 0x2e, 0xff, 0xcb, 0xc6, 0xf7, 0xc7, 0x87, 0x72, 0x16, 0xe0, 0x9b, 0xef,
	0x00, 0x00, 0x00, 0xff, 0xff, 0x6e, 0x37, 0x35, 0xf6, 0xa3, 0x01, 0x00, 0x00,
}
