// Code generated by protoc-gen-go. DO NOT EDIT.
// source: yandex/cloud/mdb/mongodb/v1/backup.proto

package mongodb

import (
	fmt "fmt"
	proto "github.com/golang/protobuf/proto"
	timestamp "github.com/golang/protobuf/ptypes/timestamp"
	math "math"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

// A MongoDB Backup resource. For more information, see the
// [Developer's Guide](/docs/managed-mongodb/concepts).
type Backup struct {
	// ID of the backup.
	Id string `protobuf:"bytes,1,opt,name=id,proto3" json:"id,omitempty"`
	// ID of the folder that the backup belongs to.
	FolderId string `protobuf:"bytes,2,opt,name=folder_id,json=folderId,proto3" json:"folder_id,omitempty"`
	// Creation timestamp in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format
	// (i.e. when the backup operation was completed).
	CreatedAt *timestamp.Timestamp `protobuf:"bytes,3,opt,name=created_at,json=createdAt,proto3" json:"created_at,omitempty"`
	// ID of the MongoDB cluster that the backup was created for.
	SourceClusterId string `protobuf:"bytes,4,opt,name=source_cluster_id,json=sourceClusterId,proto3" json:"source_cluster_id,omitempty"`
	// Time when the backup operation was started.
	StartedAt *timestamp.Timestamp `protobuf:"bytes,5,opt,name=started_at,json=startedAt,proto3" json:"started_at,omitempty"`
	// Shard names used as a source for backup.
	SourceShardNames     []string `protobuf:"bytes,6,rep,name=source_shard_names,json=sourceShardNames,proto3" json:"source_shard_names,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *Backup) Reset()         { *m = Backup{} }
func (m *Backup) String() string { return proto.CompactTextString(m) }
func (*Backup) ProtoMessage()    {}
func (*Backup) Descriptor() ([]byte, []int) {
	return fileDescriptor_461e9a87253eb299, []int{0}
}

func (m *Backup) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Backup.Unmarshal(m, b)
}
func (m *Backup) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Backup.Marshal(b, m, deterministic)
}
func (m *Backup) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Backup.Merge(m, src)
}
func (m *Backup) XXX_Size() int {
	return xxx_messageInfo_Backup.Size(m)
}
func (m *Backup) XXX_DiscardUnknown() {
	xxx_messageInfo_Backup.DiscardUnknown(m)
}

var xxx_messageInfo_Backup proto.InternalMessageInfo

func (m *Backup) GetId() string {
	if m != nil {
		return m.Id
	}
	return ""
}

func (m *Backup) GetFolderId() string {
	if m != nil {
		return m.FolderId
	}
	return ""
}

func (m *Backup) GetCreatedAt() *timestamp.Timestamp {
	if m != nil {
		return m.CreatedAt
	}
	return nil
}

func (m *Backup) GetSourceClusterId() string {
	if m != nil {
		return m.SourceClusterId
	}
	return ""
}

func (m *Backup) GetStartedAt() *timestamp.Timestamp {
	if m != nil {
		return m.StartedAt
	}
	return nil
}

func (m *Backup) GetSourceShardNames() []string {
	if m != nil {
		return m.SourceShardNames
	}
	return nil
}

func init() {
	proto.RegisterType((*Backup)(nil), "yandex.cloud.mdb.mongodb.v1.Backup")
}

func init() {
	proto.RegisterFile("yandex/cloud/mdb/mongodb/v1/backup.proto", fileDescriptor_461e9a87253eb299)
}

var fileDescriptor_461e9a87253eb299 = []byte{
	// 290 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x84, 0x91, 0xbd, 0x4e, 0xf3, 0x30,
	0x18, 0x85, 0xd5, 0xf4, 0xfb, 0x2a, 0x62, 0x24, 0x7e, 0x3c, 0x45, 0xed, 0x40, 0xc5, 0x14, 0x21,
	0x6a, 0xab, 0x30, 0x21, 0xa6, 0x96, 0x01, 0x75, 0x61, 0x28, 0x4c, 0x2c, 0x91, 0xed, 0xd7, 0x75,
	0x23, 0xe2, 0xb8, 0xf2, 0x4f, 0x05, 0x17, 0xc0, 0x7d, 0xa3, 0xda, 0xee, 0x0a, 0x5b, 0x74, 0xce,
	0x93, 0xf3, 0x48, 0xaf, 0x51, 0xfd, 0xc5, 0x7a, 0x90, 0x9f, 0x54, 0x74, 0x26, 0x00, 0xd5, 0xc0,
	0xa9, 0x36, 0xbd, 0x32, 0xc0, 0xe9, 0x7e, 0x4e, 0x39, 0x13, 0x1f, 0x61, 0x47, 0x76, 0xd6, 0x78,
	0x83, 0x27, 0x89, 0x24, 0x91, 0x24, 0x1a, 0x38, 0xc9, 0x24, 0xd9, 0xcf, 0xc7, 0x57, 0xca, 0x18,
	0xd5, 0x49, 0x1a, 0x51, 0x1e, 0x36, 0xd4, 0xb7, 0x5a, 0x3a, 0xcf, 0x74, 0xfe, 0xfb, 0xfa, 0xbb,
	0x40, 0xa3, 0x65, 0x9c, 0xc3, 0x67, 0xa8, 0x68, 0xa1, 0x1a, 0x4c, 0x07, 0x75, 0xb9, 0x2e, 0x5a,
	0xc0, 0x13, 0x54, 0x6e, 0x4c, 0x07, 0xd2, 0x36, 0x2d, 0x54, 0x45, 0x8c, 0x4f, 0x52, 0xb0, 0x02,
	0xfc, 0x80, 0x90, 0xb0, 0x92, 0x79, 0x09, 0x0d, 0xf3, 0xd5, 0x70, 0x3a, 0xa8, 0x4f, 0xef, 0xc6,
	0x24, 0xd9, 0xc8, 0xd1, 0x46, 0xde, 0x8e, 0xb6, 0x75, 0x99, 0xe9, 0x85, 0xc7, 0x37, 0xe8, 0xd2,
	0x99, 0x60, 0x85, 0x6c, 0x44, 0x17, 0x9c, 0x4f, 0xfb, 0xff, 0xe2, 0xfe, 0x79, 0x2a, 0x9e, 0x52,
	0x9e, 0x34, 0xce, 0x33, 0x9b, 0x35, 0xff, 0xff, 0xd6, 0x64, 0x7a, 0xe1, 0xf1, 0x2d, 0xc2, 0x59,
	0xe3, 0xb6, 0xcc, 0x42, 0xd3, 0x33, 0x2d, 0x5d, 0x35, 0x9a, 0x0e, 0xeb, 0x72, 0x7d, 0x91, 0x9a,
	0xd7, 0x43, 0xf1, 0x72, 0xc8, 0x97, 0xab, 0xf7, 0x67, 0xd5, 0xfa, 0x6d, 0xe0, 0x44, 0x18, 0x4d,
	0xd3, 0x49, 0x67, 0xe9, 0xf8, 0xca, 0xcc, 0x94, 0xec, 0xa3, 0x8c, 0xfe, 0xf2, 0x2a, 0x8f, 0xf9,
	0x93, 0x8f, 0x22, 0x7a, 0xff, 0x13, 0x00, 0x00, 0xff, 0xff, 0xbe, 0xb9, 0x9c, 0x42, 0xc3, 0x01,
	0x00, 0x00,
}
