<!-- Code generated from the comments of the SourceMachineConfig struct in builder/triton/source_machine_config.go; DO NOT EDIT MANUALLY -->

-   `source_machine_name` (string) - Name of the VM used for building the
    image. Does not affect (and does not have to be the same) as the name for a
    VM instance running this image. Maximum 512 characters but should in
    practice be much shorter (think between 5 and 20 characters). For example
    mysql-64-server-image-builder. When omitted defaults to
    packer-builder-[image_name].
    
-   `source_machine_networks` ([]string) - The UUID's of Triton
    networks added to the source machine used for creating the image. For
    example if any of the provisioners which are run need Internet access you
    will need to add the UUID's of the appropriate networks here. If this is
    not specified, instances will be placed into the default Triton public and
    internal networks.
    
-   `source_machine_metadata` (map[string]string) - Triton metadata
    applied to the VM used to create the image. Metadata can be used to pass
    configuration information to the VM without the need for networking. See
    Using the metadata
    API in the
    Joyent documentation for more information. This can for example be used to
    set the user-script metadata key to have Triton start a user supplied
    script after the VM has booted.
    
-   `source_machine_tags` (map[string]string) - Tags applied to the
    VM used to create the image.
    
-   `source_machine_firewall_enabled` (bool) - Whether or not the firewall
    of the VM used to create an image of is enabled. The Triton firewall only
    filters inbound traffic to the VM. All outbound traffic is always allowed.
    Currently this builder does not provide an interface to add specific
    firewall rules. Unless you have a global rule defined in Triton which
    allows SSH traffic enabling the firewall will interfere with the SSH
    provisioner. The default is false.
    
-   `source_machine_image_filter` (MachineImageFilter) - Filters used to populate the
    source_machine_image field. Example:
    