<!-- Code generated from the comments of the ISOConfig struct in common/iso_config.go; DO NOT EDIT MANUALLY -->

-   `iso_checksum_url` (string) - An URL to a checksum file containing a checksum for the ISO file. At
    least one of `iso_checksum` and `iso_checksum_url` must be defined.
    `iso_checksum_url` will be ignored if `iso_checksum` is non empty.
    
-   `iso_checksum_type` (string) - The algorithm to be used when computing the checksum of the file
    specified in `iso_checksum`. Currently, valid values are "", "none",
    "md5", "sha1", "sha256", "sha512" or "file". Since the validity of ISO
    and virtual disk files are typically crucial to a successful build,
    Packer performs a check of any supplied media by default. While setting
    "none" will cause Packer to skip this check, corruption of large files
    such as ISOs and virtual hard drives can occur from time to time. As
    such, skipping this check is not recommended. `iso_checksum_type` must
    be set to `file` when `iso_checksum` is an url.
    
-   `iso_urls` ([]string) - Multiple URLs for the ISO to download. Packer will try these in order.
    If anything goes wrong attempting to download or while downloading a
    single URL, it will move on to the next. All URLs must point to the same
    file (same checksum). By default this is empty and `iso_url` is used.
    Only one of `iso_url` or `iso_urls` can be specified.
    
-   `iso_target_path` (string) - The path where the iso should be saved after download. By default will
    go in the packer cache, with a hash of the original filename and
    checksum as its name.
    
-   `iso_target_extension` (string) - The extension of the iso file after download. This defaults to `iso`.
    